      SUBROUTINE READ_FORCING(nldas,f,tair,spfh,psfc,uwind,vwind,
     &   edasswrd,lwrd,edasprec,convprec,cape,swrd,skin,prec,lb,filnam,
     &   lugb)
C__________________________________________________________________
C  abstract:  Sample code for reading hourly LDAS forcing file in
C  GRIB format, unpacking, and storing parameters (13 forcing grids)
C  in separate binary arrays.  Intended for use in LDAS drivers.       
C
C  author:  Marshall
C  org:  NCEP/EMC/MMB
C  date: 12 March 1999
C
C  modified by D. Lohmann for 2-D NOAH input

        implicit none

        integer i, n, j, lugi, jpds(25), jgds(22), kpds(25), kgds(22),
     +          iret, jret, kf, k, nldas, lugb, parmid(13) 

        real f(nldas), tair(nldas), spfh(nldas), psfc(nldas), 
     +       uwind(nldas), vwind(nldas), edasswrd(nldas), lwrd(nldas),
     +       edasprec(nldas),convprec(nldas),cape(nldas),swrd(nldas),
     +       skin(nldas), prec(nldas)

        character filnam*100
        character clugb*2

        logical*1 lb(nldas)
C
C  CONSTANTS, DATA STATEMENTS, ETC...
C
        data parmid /11,51,1,33,34,204,205,61,63,157,204,118,61/

C  OPEN INPUT FILE AND SEARCH FOR GRIB MESSAGE SPECIFIED BY
C  jpds(5) AND jpds(2)

        do i = 1, 13
          j = 0
          lugi = 0 
          jpds = -1
          jpds(5) = parmid(i)
          if ((i.eq.11).or.(i.eq.12)) then
            jpds(2) = 154
          end if
          if (i.eq.13) then
            jpds(2) = 155
          end if
          call baopen (lugb, filnam, jret)
          call getgb (lugb, lugi, nldas, j, jpds, jgds, kf, k,
     +                kpds, kgds, lb, f, iret)
          call baclose(lugb,jret)
          print*, 'i= ', i, ' iret= ', iret, ' kpds(5)= ', kpds(5),
     +            ' jret= ', jret, ' lugb= ', lugb

C  COPY RETURNED DATA INTO ITS RESPECTIVE BINARY ARRAY.  NOTE
C  DATA ARE ASSIGNED TO PROPER ARRAY BASED ON LOOP INDEX (i).  

          if (i.eq.1) then
             do n = 1, nldas
                tair(n) = f(n)
             end do
          else if (i.eq.2) then
             do n = 1, nldas
                spfh(n) = f(n)
             end do
          else if (i.eq.3) then
             do n = 1, nldas
                psfc(n) = f(n)
             end do
          else if (i.eq.4) then
             do n = 1, nldas
                uwind(n) = f(n)
             end do
          else if (i.eq.5) then
             do n = 1, nldas
                vwind(n) = f(n)
             end do
          else if (i.eq.6) then
             do n = 1, nldas
                edasswrd(n) = f(n)
             end do
          else if (i.eq.7) then
             do n = 1, nldas
                lwrd(n) = f(n)
             end do
          else if (i.eq.8) then
             do n = 1, nldas
                edasprec(n) = f(n)
             end do
          else if (i.eq.9) then
             do n = 1, nldas
                convprec(n) = f(n)
             end do
          else if (i.eq.10) then
             do n = 1, nldas
                cape(n) = f(n)
             end do
          else if (i.eq.11) then
             do n = 1, nldas
                if ((f(n) .eq. -999.0) .or. (iret .ne. 0)) then
                   swrd(n) = edasswrd(n)
                else
                   swrd(n) = f(n)
C                   swrd(n) = edasswrd(n)
                end if
             end do
          else if (i.eq.12) then
             do n = 1, nldas
                skin(n) = f(n)
             end do
          else if (i.eq.13) then
             if (iret .eq. 0) then
                do n = 1, nldas
                   prec(n) = f(n)
                end do
             else
                do n = 1, nldas
                   prec(n) = edasprec(n)
                end do
             end if
          end if
        end do

        end     
